using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Role;
namespace CMSMicroservice.Protobuf.Validator.Role;

public class GetAllRoleByFilterRequestValidator : AbstractValidator<GetAllRoleByFilterRequest>
{
    public GetAllRoleByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllRoleByFilterRequest>.CreateWithOptions((GetAllRoleByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
